<?php

declare(strict_types=1);

namespace Dedi\SyliusCustomerReferralPlugin\Application\EventListener;

use Dedi\SyliusCustomerReferralPlugin\Domain\Referral\Model\ReferralModelInterface;
use Dedi\SyliusCustomerReferralPlugin\Domain\Referral\UseCase\AcceptInvite\AcceptInviteOutput;
use Dedi\SyliusCustomerReferralPlugin\Domain\Referral\UseCase\AcceptInvite\AcceptInvitePresenterInterface;
use Sylius\Component\Core\Model\ShopUserInterface;
use Sylius\Component\Customer\Model\CustomerInterface;

class CustomerPostRegisterEventListenerPresenter implements AcceptInvitePresenterInterface
{
    /** @var ReferralModelInterface */
    private $referral;

    public function present(AcceptInviteOutput $output): void
    {
        $this->referral = $output->getReferralModel();
    }

    public function getReferral()
    {
        return $this->referral;
    }

    public function getInviteeCustomer(): ?CustomerInterface
    {
        /** @var ShopUserInterface $invitee */
        $invitee = $this->referral->getInvitee();

        return $invitee->getCustomer();
    }

    public function getInviterCustomer(): ?CustomerInterface
    {
        /** @var ShopUserInterface $inviter */
        $inviter = $this->referral->getInviter();

        return $inviter->getCustomer();
    }
}
